﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace MotorBoat
{
    internal class BoatCompareByColor : IComparer<IDrawningObject>
    {
        public int Compare(IDrawningObject? x, IDrawningObject? y)
        {
            if (x == null && y == null)
            {
                return 0;
            }
            if (x == null && y != null)
            {
                return 1;
            }
            if (x != null && y == null)
            {
                return -1;
            }
            var xShip = x as DrawningObjectBoat;
            var yShip = y as DrawningObjectBoat;
            if (xShip == null && yShip == null)
            {
                return 0;
            }
            if (xShip == null && yShip != null)
            {
                return 1;
            }
            if (xShip != null && yShip == null)
            {
                return -1;
            }
            var xEntityShip = xShip.GetShip.Boat;
            var yEntityShip = yShip.GetShip.Boat;
            var baseColorCompare = xEntityShip.BodyColor.ToArgb().CompareTo(yEntityShip.BodyColor.ToArgb());
            if (baseColorCompare != 0)
            {
                return baseColorCompare;
            }
            if (xEntityShip is EntityMotorBoat xWarmlyShip && yEntityShip is EntityMotorBoat yWarmlyShip)
            {
                var dopColorCompare = xWarmlyShip.DopColor.ToArgb().CompareTo(yWarmlyShip.DopColor.ToArgb());
                if (dopColorCompare != 0)
                {
                    return dopColorCompare;
                }
            }
            var speedCompare = xShip.GetShip.Boat.Speed.CompareTo(yShip.GetShip.Boat.Speed);
            if (speedCompare != 0)
            {
                return speedCompare;
            }
            return xShip.GetShip.Boat.Weight.CompareTo(yShip.GetShip.Boat.Weight);
        }
    }
}
