﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace MotorBoat
{
    internal class BoatCompareByType : IComparer<IDrawningObject>
    {
        public int Compare(IDrawningObject? x, IDrawningObject? y)
        {
            if (x == null && y == null)
            {
                return 0;
            }
            if (x == null && y != null)
            {
                return 1;
            }
            if (x != null && y == null)
            {
                return -1;
            }
            var xCar = x as DrawningObjectBoat;
            var yCar = y as DrawningObjectBoat;
            if (xCar == null && yCar == null)
            {
                return 0;
            }
            if (xCar == null && yCar != null)
            {
                return 1;
            }
            if (xCar != null && yCar == null)
            {
                return -1;
            }
            if (xCar.GetShip.GetType().Name != yCar.GetShip.GetType().Name)
            {
                if (xCar.GetShip.GetType().Name == "DrawningBoat")
                {
                    return -1;
                }
                return 1;
            }
            var speedCompare =
           xCar.GetShip.Boat.Speed.CompareTo(yCar.GetShip.Boat.Speed);
            if (speedCompare != 0)
            {
                return speedCompare;
            }
            return xCar.GetShip.Boat.Weight.CompareTo(yCar.GetShip.Boat.Weight);
        }
    }
}
