using System;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace MotorBoat
{
    public partial class FormBoat : Form
    {
        private DrawningBoat _boat;
        public DrawningBoat SelectedBoat { get; private set; }
        public FormBoat()
        {
            InitializeComponent();
        }
        private void ButtonCreate_Click(object sender, EventArgs e)
        {
            Random rnd = new();
            Color color = Color.FromArgb(rnd.Next(0, 256), rnd.Next(0, 256),
           rnd.Next(0, 256));
            ColorDialog dialog = new();
            if (dialog.ShowDialog() == DialogResult.OK)
            {
                color = dialog.Color;
            }
            _boat = new DrawningBoat(rnd.Next(100, 300), rnd.Next(1000, 2000),
           color);
            SetData();
            Draw();

        }
        private void Draw()
        {
            Bitmap bmp = new Bitmap(pictureBoxMotorBoat.Width, pictureBoxMotorBoat.Height);
            Graphics gr = Graphics.FromImage(bmp);
            _boat?.DrawTransport(gr);
            pictureBoxMotorBoat.Image = bmp;
        }
        private void SetData()
        {
            Random rnd = new();
            _boat.SetPosition(rnd.Next(10, 100), rnd.Next(10, 100), pictureBoxMotorBoat.Width, pictureBoxMotorBoat.Height);
            toolStripStatusLabelSpeed.Text = $": {_boat.Boat.Speed}";
            toolStripStatusLabelWeight.Text = $": {_boat.Boat.Weight}";
            toolStripStatusLabelBodyColor.Text = $": {_boat.Boat.BodyColor.Name}";
        }
        private void PictureBoxCar_Resize(object sender, EventArgs e)
        {
            _boat?.ChangeBorders(pictureBoxMotorBoat.Width, pictureBoxMotorBoat.Height);
            Draw();
        }

        private void ButtonMove_Click(object sender, EventArgs e)
        {
            //  
            string name = ((Button)sender)?.Name ?? string.Empty;
            switch (name)
            {
                case "buttonUp":
                    _boat?.MoveTransport(Direction.Up);
                    break;
                case "buttonDown":
                    _boat?.MoveTransport(Direction.Down);
                    break;
                case "buttonLeft":
                    _boat?.MoveTransport(Direction.Left);
                    break;
                case "buttonRight":
                    _boat?.MoveTransport(Direction.Right);
                    break;
            }
            Draw();
        }
        ///    ""
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void buttonCreateModif_Click(object sender, EventArgs e)
        {
            Random rnd = new();
            Color color = Color.FromArgb(rnd.Next(0, 256), rnd.Next(0, 256),
           rnd.Next(0, 256));
            ColorDialog dialog = new();
            if (dialog.ShowDialog() == DialogResult.OK)
            {
                color = dialog.Color;
            }
            Color dopColor = Color.FromArgb(rnd.Next(0, 256), rnd.Next(0, 256),
           rnd.Next(0, 256));
            ColorDialog dialogDop = new();
            if (dialogDop.ShowDialog() == DialogResult.OK)
            {
                dopColor = dialogDop.Color;
            }
            _boat = new DrawningMotorBoat(rnd.Next(100, 300), rnd.Next(1000, 2000),
           color, dopColor,
            Convert.ToBoolean(rnd.Next(0, 2)), Convert.ToBoolean(rnd.Next(0,
           2)), Convert.ToBoolean(rnd.Next(0, 2)));
            SetData();
            Draw();
        }

        private void buttonSelectBoat_Click(object sender, EventArgs e)
        {
            SelectedBoat = _boat;
            DialogResult = DialogResult.OK;
        }
    }
}
