﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace MotorBoat
{
    public partial class FormBoatConfig : Form
    {
        private event Action<DrawningBoat> EventAddBoat;
        DrawningBoat _boat = null;
        public FormBoatConfig()
        {
            InitializeComponent();
            panelBlack.MouseDown += PanelColor_MouseDown;
            panelPurple.MouseDown += PanelColor_MouseDown;
            panelGray.MouseDown += PanelColor_MouseDown;
            panelGreen.MouseDown += PanelColor_MouseDown;
            panelRed.MouseDown += PanelColor_MouseDown;
            panelWhite.MouseDown += PanelColor_MouseDown;
            panelYellow.MouseDown += PanelColor_MouseDown;
            panelBlue.MouseDown += PanelColor_MouseDown;
            buttonCancel.Click += (s, a) => Close();
        }

        public void AddEvent(Action<DrawningBoat> ev)
        {
            if (EventAddBoat == null)
            {
                EventAddBoat = new Action<DrawningBoat>(ev);
            }
            else
            {
                EventAddBoat += ev;
            }
        }

        private void DrawBoat()
        {
            Bitmap bmp = new(pictureBoxObject.Width, pictureBoxObject.Height);
            Graphics gr = Graphics.FromImage(bmp);
            _boat?.SetPosition(5, 135, pictureBoxObject.Width,
           pictureBoxObject.Height);
            _boat?.DrawTransport(gr);
            pictureBoxObject.Image = bmp;
        }

        private void labelSimpleObject_MouseDown(object sender, MouseEventArgs e)
        {
            (sender as Label).DoDragDrop((sender as Label).Name,DragDropEffects.Move | DragDropEffects.Copy);

        }

        private void panelobject_DragEnter(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(DataFormats.Text))
            {
                e.Effect = DragDropEffects.Copy;
            }
            else
            {
                e.Effect = DragDropEffects.None;
            }
        }

        private void panelobject_DragDrop(object sender, DragEventArgs e)
        {
            switch (e.Data.GetData(DataFormats.Text).ToString())
            {
                case "labelSimpleObject":
                    {
                        _boat = new DrawningBoat((int)numericUpDownSpeed.Value, (int)numericUpDownWeight.Value, Color.White);
                    }
                    break;
                case "labelHardObject":
                    {
                        _boat = new DrawningMotorBoat((int)numericUpDownSpeed.Value, (int)numericUpDownWeight.Value, Color.White, Color.Black, checkBoxNose.Checked, checkBoxSide.Checked, checkBoxBackside.Checked);
                    }
                    break;
            }
            DrawBoat();
        }

        private void buttonOk_Click(object sender, EventArgs e)
        {
            EventAddBoat?.Invoke(_boat);
            Close();
        }

        private void PanelColor_MouseDown(object sender, MouseEventArgs e)
        {
            (sender as Control).DoDragDrop((sender as Control).BackColor, DragDropEffects.Move | DragDropEffects.Copy);
        }

        private void LabelBaseColor_DragDrop(object sender, DragEventArgs e)
        {
            if (_boat != null)
            {
                _boat.SetBodyColor((Color)e.Data.GetData(typeof(Color)));
                DrawBoat();
            }
            else return;
        }

        private void LabelDopColor_DragDrop(object sender, DragEventArgs e)
        {
            if(_boat is not DrawningMotorBoat MotorBoat || _boat==null)
            {
                return;
            }
            MotorBoat.SetExtraColor((Color)e.Data.GetData(typeof(Color)));
            DrawBoat();
        }

        private void LabelBaseColor_DragEnter(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(typeof(Color)))
            {
                e.Effect = DragDropEffects.Copy;
            }
            else
            {
                e.Effect = DragDropEffects.None;
            }
        }

        private void LabelDopColor_DragEnter(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(typeof(Color)))
            {
                e.Effect = DragDropEffects.Copy;
            }
            else
            {
                e.Effect = DragDropEffects.None;
            }
        }
    }
}
